#include <basic.h>
#include <bstdio.h>
#include <btron/hmi.h>
#include <btron/vobj.h>
#include <btron/libapp.h>

extern WEVENT wevt;

static WINFOREC winfo[2];

void idle_fn()
{
  if (wevt.s.wid == winfo[0].wid &&
      wevt.s.cmd == W_WORK && (wevt.s.stat & ES_CMD) == 0){
    gset_ptr(PS_SELECT, NULL, -1, -1);
  }
  return;
}

void disp_fn(W wno, W mode, RECT* r)
{
  switch (mode){
  case -1: case 0: case 1: case 3:
  case 5:  case 6: case 7: case 9:
    do {
      if (wsta_dsp(winfo[wno].wid, NULL, NULL) == 0)
        break;
      wera_wnd(winfo[wno].wid, NULL);
      // <--- ˺
    } while (wend_dsp(winfo[wno].wid) > 0);
    break;
  default: // ¾
    break;
  }
  return;
}

W finish_fn(W wno, W mode)
{
  return 1; // λǤ뤳Ȥ򳰤
}

static WFUNCREC wfunc = {
  NULL,        // bgfn
  idle_fn,     // idlefn
  NULL,        // msgfn
  NULL,        // menufn
  disp_fn,     // dspfn
  NULL,        // stsfn
  NULL,        // keyfn
  NULL,        // presfn
  finish_fn,   // finfn
  NULL,        // pastefn
  NULL,        // respfn
  NULL,        // scrlfn
  NULL,        // devfn
  NULL         // vobjfn
};

extern "C" W main(W argc, TC* argv[])
{
  TC text[] = {L"ȣף䡪"};
  RECT r = {{ 100, 100, 400, 300 }};
  W err, fid, ret;

  fid = dopn_dat(NULL);
  if (fid < 0){
    printf("dopn_dat: %d\n", fid);
    ext_prc(1);
  }

  // ɥIDϡɥ쥳ɤ˳Ǽ
  winfo[0].wid = wopn_wnd(WA_STD, 0, &r, NULL, 2, text, NULL, NULL);
  if (winfo[0].wid < 0){
    printf("wopn_wnd: %d\n", winfo[0].wid);
    ext_prc(1);
  }
  winfo[1].wid = 0; // <--- winfo[0]ޤǤܤäƤʤȤ򼨤

  // ٥ȥ롼פϤäΤ
  do {
    ret = evt_loop(&wfunc, winfo);
  } while (ret == 0);

  err = wcls_wnd(winfo[0].wid, CLR);
  if (err < 0){
    printf("wcls_wnd: %d\n", err);
    ext_prc(1);
  }

  ext_prc(0);
}
